// Global vars
    var CoverArtFileName;
    var UserPlaylist;
    var DirectoryPath;
    var PlayState;
    var Transition;
    var UserVolume;
	var DisplayText;
	var UserText;
    var ScrollArtistName;
    var TrackIsPlaying;
    var StartingUp;

 //timer for track position bar
    var updatePosition=self.setInterval("positionChanged()",1000); 

//transition effects
    var transitionTime = "1.0";
    var filters = new Array(17);
    filters[0] = 'RANDOM';
    filters[1] = 'progid:DXImageTransform.Microsoft.Barn(duration=' + transitionTime+ ',orientation=vertical)';
    filters[2] = 'progid:DXImageTransform.Microsoft.Blinds(duration=' + transitionTime+ ',bands=20)';
    filters[3] = 'progid:DXImageTransform.Microsoft.Checkerboard(duration=' + transitionTime+ ',squaresX=20,squaresY=20)';
    filters[4] = 'progid:DXImageTransform.Microsoft.Fade(duration=' + transitionTime + ')';
    filters[5] = 'progid:DXImageTransform.Microsoft.GradientWipe(duration=' + transitionTime + ')';
    filters[6] = 'progid:DXImageTransform.Microsoft.Inset(duration=' + transitionTime + ')';
    filters[7] = 'progid:DXImageTransform.Microsoft.Iris(duration=' + transitionTime+ ',motion=out)';
    filters[8] = 'progid:DXImageTransform.Microsoft.Pixelate(duration=' + transitionTime+ ',maxSquare=10)';
    filters[9] = 'progid:DXImageTransform.Microsoft.RadialWipe(duration=' + transitionTime+ ',wipeStyle=clock)';
    filters[10] = 'progid:DXImageTransform.Microsoft.RandomBars(duration=' + transitionTime+ ',orientation=vertical)';
    filters[11] = 'progid:DXImageTransform.Microsoft.RandomDissolve(duration=' + transitionTime+ ',orientation=vertical)';
    filters[12] = 'progid:DXImageTransform.Microsoft.Slide(duration=' + transitionTime+ ',slideStyle=push)';
    filters[13] = 'progid:DXImageTransform.Microsoft.Spiral(duration=' + transitionTime+ ',gridSizeX=40,gridSizeY=40)';
    filters[14] = 'progid:DXImageTransform.Microsoft.Stretch(duration=' + transitionTime+ ',stretchStyle=push)';
    filters[15] = 'progid:DXImageTransform.Microsoft.Strips(duration=' + transitionTime+ ',motion=rightdown)';
    filters[16] = 'progid:DXImageTransform.Microsoft.Wheel(duration=' + transitionTime+ ',spokes=12)';
    filters[17] = 'progid:DXImageTransform.Microsoft.Zigzag(duration=' + transitionTime+ ',gridSizeX=6, gridSizeY=6)';  

	
// Called when gadget is opened
function setup(){
    System.Gadget.settingsUI = "settings.htm";
    System.Gadget.onSettingsClosed = SettingsClosed;
	System.Gadget.Flyout.onHide=function() {flyoutClosed();}
	Player.uiMode = "none";
	Player.windowlessVideo = true;

// Retrieve persistent settings, and store in temporary session settings
    SettingsManager.loadFile();
    UserPlaylist = SettingsManager.getValue("Default", "dd_playlist","All Music" );
    System.Gadget.Settings.write ("dd_playlist", UserPlaylist);

    UserSkin= SettingsManager.getValue("Default", "skin","0" );
    System.Gadget.Settings.write ("skin", UserSkin);

    Transition=SettingsManager.getValue("Default", "dd_transition","(Random transition)" );
    System.Gadget.Settings.write ("dd_transition", Transition);

    DisplayText=SettingsManager.getValue("Default", "display","0" );
    System.Gadget.Settings.write ("display", DisplayText);
	
    UserText=SettingsManager.getValue("Default", "usertext","My Player" );
    System.Gadget.Settings.write ("usertext", UserText);	

// Set volume
    Player.settings.volume =  50;
    Volume.innerText=Player.settings.volume

// Set skin
   if (System.Gadget.Settings.read("skin")==0)   {
		document.getElementById('skin').href = "css/skin0.css";
		System.Gadget.background = "images/back_dark.png";
		}
		
   if (System.Gadget.Settings.read("skin")==1) {
	document.getElementById('skin').href = "css/skin1.css";
	System.Gadget.background = "images/back_light.png";
	}

// Set up and start player
    Player.settings.autoStart=false;
    Player.settings.setMode("shuffle",true);
    Player.settings.setMode("loop",true);
    StartingUp=true;
    Player.currentPlaylist = Player.PlaylistCollection.getByName(UserPlaylist).item(0);
    ShowPlayButton();
    StartingUp=false;
} //end setup



function SettingsClosed(event) {
     if (event.closeAction == event.Action.commit){
        var OldUserPlaylist=Player.currentPlaylist.name; 
        if (System.Gadget.Settings.read("skin")==0) {
			document.getElementById('skin').href = "css/skin0.css";
			System.Gadget.background = "images/back_dark.png";
			}
        if (System.Gadget.Settings.read("skin")==1) {
			document.getElementById('skin').href = "css/skin1.css";
			System.Gadget.background = "images/back_light.png";
			}

        UserPlaylist=System.Gadget.Settings.read ("dd_playlist");
        Transition=System.Gadget.Settings.read ("dd_transition");

        if (UserPlaylist != OldUserPlaylist){
            Player.controls.stop(); 
            Player.currentPlaylist = Player.PlaylistCollection.getByName(UserPlaylist).item(0);
			if (Player.currentPlaylist.count == 0) {
				Player.currentPlaylist = Player.PlaylistCollection.getByName("All Music").item(0);
				UserPlaylist=Player.currentPlaylist.name;
				System.Gadget.Settings.write("dd_playlist",UserPlaylist);
				}
            Player.controls.play(); 
            ShowPauseButton();
        }
		DisplayText = System.Gadget.Settings.read ("display");
		UserText = System.Gadget.Settings.read ("usertext");
		if(DisplayText == 0 ) {topText.innerHTML=Player.currentMedia.getItemInfo('Artist');}
		if(DisplayText == 1 ) {topText.innerHTML=Player.currentMedia.getItemInfo('Title');}
		if(DisplayText == 2 ) {topText.innerHTML=Player.currentMedia.getItemInfo('Album');}
		if(DisplayText == 3 ) {topText.innerHTML=UserPlaylist;}
		if(DisplayText == 4 ) {topText.innerHTML=UserText;}

// Save the settings
        SettingsManager.setValue("Default", "dd_playlist",Player.currentPlaylist.name);
        SettingsManager.setValue("Default", "skin",System.Gadget.Settings.read("skin") );
        SettingsManager.setValue("Default", "dd_transition",Transition );
        SettingsManager.setValue("Default", "display",DisplayText);
		SettingsManager.setValue("Default", "usertext",UserText);
        SettingsManager.saveFile();
     }
}

function fileDragDropped() {
    var  sFile;
    for (var i=0; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null; i++)
    { sFile = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;  }
    var newItem = Player.newMedia(sFile);
    Player.currentPlaylist.insertItem(100,newItem);
    listItem=Player.currentPlaylist.item(100);
    Player.controls.playItem(listItem);
}

function mediaChanged(){
    UpdateArt();
    addContentToFlyout();
    if(DisplayText == 0 ) {topText.innerHTML=Player.currentMedia.getItemInfo('Artist');}
    if(DisplayText == 1 ) {topText.innerHTML=Player.currentMedia.getItemInfo('Title');}
	if(DisplayText == 2 ) {topText.innerHTML=Player.currentMedia.getItemInfo('Album');}
	if(DisplayText == 3 ) {topText.innerHTML=UserPlaylist;}
	if(DisplayText == 4 ) {topText.innerHTML=UserText;}
}

function positionChanged(){
  //updates progress bar
  if (Player.currentMedia != null)
  {progress.width= Math.min(118,(Player.controls.currentPosition / Player.currentMedia.getItemInfo ("Duration")) * 118);}
}

///////// functions to handle the media controls

function ShowPlayButton(){
       b2.src="images/play.png";
       b2.onmouseenter= function() {b2.src='images/play2.png'}
       b2.onmouseleave= function() {b2.src='images/play.png'}
       b2.onmousedown= function()  {b2.src='images/play.png'}
       b2.onmouseup= function()    {b2.src='images/play2.png'}
       TrackIsPlaying=false;
}

function ShowPauseButton(){
       b2.src="images/pause.png";
       b2.onmouseenter= function() {b2.src='images/pause2.png'}
       b2.onmouseleave= function() {b2.src='images/pause.png'}
       b2.onmousedown= function()  {b2.src='images/pause.png'}
       b2.onmouseup=  function()   {b2.src='images/pause2.png'}
       TrackIsPlaying=true;
}

function PlayPause(){
    if (TrackIsPlaying)   {
        Player.controls.pause();
        ShowPlayButton();
     }
    else   {
        Player.controls.play();
        ShowPauseButton();
      }
}

function PreviousSong(){
	Player.controls.play();
    Player.controls.previous();
	ShowPauseButton();
}

function NextSong(){
   Player.controls.play();
   Player.controls.next();
  ShowPauseButton();
}

System.Gadget.Flyout.onShow = function() {
	if (System.Gadget.Settings.read("skin")==0) {System.Gadget.background='images/solid_dark.png';}
	if (System.Gadget.Settings.read("skin")==1) {System.Gadget.background='images/solid_light.png';}
    addContentToFlyout();
}

function showFlyout() {
    System.Gadget.Flyout.show=false;
    System.Gadget.Flyout.file = "flyout.html";
    System.Gadget.Flyout.show=true;
}

function flyoutClosed(){
	if (System.Gadget.Settings.read("skin")==0)   {
		System.Gadget.background = "images/back_dark.png";
		}
   if (System.Gadget.Settings.read("skin")==1) {
	System.Gadget.background = "images/back_light.png";
		}	
}
function addCommas(nStr){
// Adds thousands separators
    nStr += '';
    x = nStr.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? '.' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
     x1 = x1.replace(rgx, '$1' + ',' + '$2');
     }
    return x1 + x2;
}

function pathOnly (InString) {
   //strips filename from path
   var LastSlash=InString.lastIndexOf ('\\', InString.length-1);
   var OutString=InString.substring (0, LastSlash+1);
   return (OutString);	
}

function secondstotime(secs){
    var t = new Date(1970,0,1);
    t.setSeconds(secs);
    var s = t.toTimeString().substr(0,8);
    if(secs > 86399)
        s = Math.floor((t - Date.parse("1/1/70")) / 3600000) + s.substr(2);
    return s;
}

function addContentToFlyout() {
    if(System.Gadget.Flyout.show) {
       var flyoutDoc = System.Gadget.Flyout.document;
       var locationPath = Player.currentMedia.SourceURL;
       locationPath=pathOnly(locationPath);
       var searchURL = "http://www.google.com/search?q=" + Player.currentMedia.getItemInfo("Artist");

		var z =  "<ul><li><b>Artist:</b> " + Player.currentMedia.getItemInfo("Artist") + 
		"</li><li><b>Title:</b> " + Player.currentMedia.getItemInfo("Title") + 
		"</li><li><b>Album:</b> " +  Player.currentMedia.getItemInfo  ("Album") + 
		"</li><li><b>Length:</b> " + secondstotime(Player.currentMedia.getItemInfo("Duration")) + 
		"</li><li><b>Genre:</b> "+Player.currentMedia.getItemInfo ("Genre") +
		"</li><li><b>Playlist:</b> "+Player.currentPlaylist.name + " (" + addCommas(Player.currentPlaylist.count) + " tracks)" +
		"</li><li class='fakelink' onClick='gotoFolder()' title='Display the folder that contains this audio file'>Open file location"+
		" </li><li class='fakelink' onClick='searchGoogle()' title='Search for the artist using Google'>Search for artist</li>"+
		"</ul>";
		flyoutDoc.getElementById("song").innerHTML =z;
		System.Gadget.Settings.write ("trackLocation", locationPath);
		System.Gadget.Settings.write ("searchURL", searchURL);
	}
}

function getBestArt(f){
// look for files in this order: cover.jpg, folder.jpg, albumartsmall.jpg, nocover.jpg
    fullpath = Player.currentMedia.SourceURL;
    fullpath = fullpath.replace(/file:\/\/\//,""); // remove file:///
    fullpath = fullpath.replace(/\//g,"\\"); // replace slash with backslash (for use on Windows OS)
    fullpath = fullpath.replace(/%20/g," "); // replace escaped space
    var iLastBackslash = fullpath.lastIndexOf("\\");
    var thisfilename = fullpath.substring( iLastBackslash+1, fullpath.length); 
    DirectoryPath = fullpath.substring( 0, iLastBackslash ) + "\\";
    var fso = new ActiveXObject( "Scripting.FileSystemObject" );
    if (fso.FileExists(DirectoryPath + "cover.jpg" )) {return DirectoryPath + "cover.jpg";}
    if (fso.FileExists(DirectoryPath + "folder.jpg")) {return DirectoryPath + "folder.jpg";}
    if (fso.FileExists(DirectoryPath + "albumart.jpg")) {return DirectoryPath + "albumart.jpg";}
    if (fso.FileExists(DirectoryPath + "albumartsmall.jpg" )) {return DirectoryPath + "albumartsmall.jpg";}
    return "images/nocover.jpg"
}

function UpdateArt() {
    var img=document.getElementById("AlbumArt");
    ArtFile=getBestArt();
    // one last try - look for embedded art
    if (ArtFile=="images/nocover.jpg"){
      if (Player.currentMedia.getAttributeCountByType("WM/Picture", "") > 0) {
            ArtFile= Player.currentMedia.getItemInfoByType("WM/Picture", "", 0).URL;
            // This stops working after the flyout has been used.  ?!?!?!?
      }
   }

    if (Transition=="(Random transition)")  {
        var r = [Math.ceil(Math.random()*17)];
       img.style.filter=filters[r];
    }
    else {
      if (Transition=="Barn"){img.style.filter=filters[1];}
      if (Transition=="Blinds"){img.style.filter=filters[2];}
      if (Transition=="Checkerboard"){img.style.filter=filters[3];}
      if (Transition=="Fade"){img.style.filter=filters[4];}
      if (Transition=="GradientWipe"){img.style.filter=filters[5];}
      if (Transition=="Inset"){img.style.filter=filters[6];}
      if (Transition=="Iris"){img.style.filter=filters[7];}
      if (Transition=="Pixelate"){img.style.filter=filters[8];}
      if (Transition=="RadialWipe"){img.style.filter=filters[9];}
      if (Transition=="RandomBars"){img.style.filter=filters[10];}
      if (Transition=="RandomDissolve"){img.style.filter=filters[11];}
      if (Transition=="Slide"){img.style.filter=filters[12];}
      if (Transition=="Spiral"){img.style.filter=filters[13];}
      if (Transition=="Stretch"){img.style.filter=filters[14];}
      if (Transition=="Strips"){img.style.filter=filters[15];}
      if (Transition=="Wheel"){img.style.filter=filters[16];}
      if (Transition=="Zigzag"){img.style.filter=filters[17];}
    }
    img.filters[0].apply() ;
    img.src=ArtFile; 
    img.filters[0].play();
    document.images.AlbumArt.src=ArtFile;
    }

function mousewheelVolume() {
    oldVol=Player.settings.volume;
    if (event.wheelDelta >= 120)
         Player.settings.volume=oldVol+5;
    else if (event.wheelDelta <= -120)
         Player.settings.volume=oldVol-5;
    Volume.innerText=Player.settings.volume;
  }

function swapView(){
	if (playerContainer.style.visibility=="hidden") {
		playerContainer.style.visibility="visible"
	}
	else    {
		playerContainer.style.visibility="hidden"
	}
}

